# NanoBlogger Article Manager plugin

# How it works:
#	Looks for .txt files in articles directory.
#	Reads 1st line as title (NB_EntryTitle).
# 	Reads everything after 1st line as content (NB_Entries).
#	Loads the makepage.htm template.
#	Loads postformat plugins.
#	Adds links to NB_ArticleLinks.

# sample code for templates, based off the default stylesheet
#
# <div class="sidetitle">
# Articles
# </div>
# <div class="side">
# $NB_Article_Links
# </div>

ARTICLE_DIR="$BLOG_DIR/articles"
ARTICLE_PATH="\${BASE_URL}articles/"
ARTICLE_SUFFIX="txt"
ARTICLE_TEMPLATE="$NB_TEMPLATE_DIR/$MAKEPAGE_TEMPLATE"
OLD_ARCHIVES_PATH="$ARCHIVES_PATH"
ARCHIVES_PATH="${BASE_URL}$ARCHIVES_DIR/"

ARTICLE_PLUGIN_OUTFILE="$BLOG_DIR/$PARTS_DIR/article_links.$NB_FILETYPE"

if [ -d "$ARTICLE_DIR" ]; then
	add_articlelink(){
		echo '<a href="'${ARTICLE_PATH}$article_outfile'">'$NB_EntryTitle'</a><br />' >> "$ARTICLE_PLUGIN_OUTFILE"
		}

	create_article(){
		if [ -f "$ARTICLE_DIR/$article_srcfile" ]; then
			MKPAGE_OUTFILE="$ARTICLE_DIR/$article_outfile"
			NB_Entries=`sed 1d "$ARTICLE_DIR/$article_srcfile"`
			# modify page content used by make_page function
			MKPAGE_CONTENT="$NB_Entries"
			make_page "$ARTICLE_DIR/$article_srcfile" "$ARTICLE_TEMPLATE" "$MKPAGE_OUTFILE"
			#add_articlelink
		fi
		}

	cycle_articles_for(){
		build_part="$1"
		build_list=`cd "$ARTICLE_DIR"; for articles in *.$ARTICLE_SUFFIX; do echo "$articles"; done`
		[ "$build_list" = "*.$ARTICLE_SUFFIX" ] && build_list=
		article_lines=`echo "$build_list" |grep -n "." |cut -c1-2 |sed -e '/[\:\]/ s///g'`
		for line in $article_lines ; do
			article_line=`echo "$build_list" |sed -n "$line"p`
			article_srcfile=`echo "$article_line"`
			article_outfile=`chg_suffix "$article_srcfile"`
			if [ -f "$ARTICLE_DIR/$article_srcfile" ]; then
				NB_EntryTitle=`sed 1q "$ARTICLE_DIR/$article_srcfile"`
				"$build_part"
			fi
		done
		}

	> "$ARTICLE_PLUGIN_OUTFILE"
	cycle_articles_for add_articlelink
	NB_ArticleLinks="$(<$ARTICLE_PLUGIN_OUTFILE)"
	[ -f "$ARTICLE_DIR/$article_srcfile" ] && nb_msg "generating articles ..."
	cycle_articles_for create_article
fi

ARCHIVES_PATH="$OLD_ARCHIVES_PATH"

